mdadm(8)

NAME
mdadm - manage MD devices aka Linux Software Raid.

SYNOPSIS
mdadm [mode] <raiddevice> [options] <subdevices>

DESCRIPTION
RAID devices are virtual devices created from two or more real block devices. This allows multiple devices (typically disk drives or partitions there-of) to be combined into a single device to hold (for example) a single filesystem. Some RAID levels included redundancy and so can survive some degree of device failure. Linux Software RAID devices are implemented through the md (Multiple Devices) device driver. Currently, Linux supports LINEAR md devices, RAID0 (striping), RAID1 (mirroring), RAID4 and RAID5. Recent kernels (2002) also support a mode known as MULTIPATH. mdadm does not support MULTIPATH as yet. mdadm is a program that can be used to create and manage MD devices. As such it provides a similar set of functionality to the raidtools packages. The key differences between mdadm and raidtools are:

•   mdadm is a single program and not a collection of programs.

•   mdadm can perform (almost) all of its functions without having a configuration file. Also mdadm helps with management of the configuration file.

•   mdadm can provide information about your arrays (through Detail and Examine) that raidtools cannot.

•   raidtools can manage MULTIPATH devices which mdadm cannot yet manage.

MODES
mdadm has 7 major modes of operation:

Assemble
    Assemble the parts of a previously created array into an active array. Components can be explicitly given or can be searched for. mdadm checks that the components do form a bona fide array, and can, on request, fiddle superblock information so as to assemble a faulty array.

Build
    Build a legacy array without per-device superblocks.

Create
    Create a new array with per-device superblocks.

Detail
    Display the details of a given md device. Details include the RAID level, the number of devices, which ones are faulty (if any), and the array UUID.

Examine
    Examine a device to see if it is part of an md array, and print out the details of that array. This mode can also be used to examine a large number of devices and to print out a summary of the arrays found in a format suitable for the mdadm.conf configuration file.

Follow or Monitor
    Monitor one or more md devices and act on any state changes.

Manage
    This is for odd bits an pieces like hotadd, hotremove, setfaulty, stop, readonly, readwrite.

OPTIONS
Available options are:

-A, --assemble
    Assemble an existing array.

-B, --build
    Build a legacy array without superblocks.

-C, --create
    Create a new array.

-D, --detail
    Print detail of one or more md devices.

-E, --examine
    Print content of md superblock on device(s).

-F, --follow, --monitor
    Select Monitor mode.

-h, --help
    Display help message or, after above option, mode specific help message.

-V, --version
    Print version information for mdadm.

-v, --verbose
    Be more verbose about what is happening.

-b, --brief
    Be less verbose. This is used with --detail and --examine.

For create or build:

-c, --chunk=
    Specify chunk size of kibibytes. The default is 64.

--rounding=
    Specify rounding factor for linear array (==chunk size)

-l, --level=
    Set raid level. Options are: linear, raid0, 0, stripe, raid1, 1, mirror, raid5, 4, raid5, 5. Obviously some of these are synonymous. Only the first 4 are valid when Building.

-p, --parity=
    Set raid5 parity algorithm. Options are: {left,right}-{,a}symmetric, la, ra, ls, rs. The default is left-symmetric.

--layout=
    same as --parity

-n, --raid-disks=
    number of active devices in array.

-x, --spare-disks=
    number of spare (eXtra) disks in initial array. Spares can be added and removed later.

-z, --size=
    Amount (in Kibibytes) of space to use from each drive in RAID1/4/5. This must be a multiple of the chunk size, and must leave about 128Kb of space at the end of the drive for the RAID superblock. If this is not specified (as it normally is not) the smallest drive (or partition) sets the size, though if there is a variance among the drives of greater than 1%, a warning is issued.

For assemble:

-u, --uuid=
    uuid of array to assemble. Devices which don't have this uuid are excluded

-m, --super-minor=
    Minor number of device that array was created for. Devices which don't have this minor number are excluded. If you create an array as /dev/md1, then all superblock will contain the minor number 1, even if the array is later assembled as /dev/md2.

-c, --config=
    config file. Default is /etc/mdadm.conf.

-s, --scan
    scan config file for missing information

-f, --force
    Assemble the array even if some superblocks appear out-of-date

-R, --run
    Attempt to start the array even if fewer drives were given than are needed for a full array. Normally if not all drives are found and --scan is not used, then the array will be assembled but not started. With --run an attempt will be made to start it anyway.

General management

-a, --add
    hotadd listed devices.

-r, --remove
    remove listed devices. The must not be active. i.e. they should be failed or spare devices.

-f, --fail
    mark listed devices as faulty.

--set-faulty
    same as --fail.

-R, --run
    start a partially built array.

-S, --stop
    deactivate array, releasing all resources.

-o, --readonly
    mark array as readonly.

-w, --readwrite
    mark array as readwrite.

ASSEMBLY MODE

Usage: mdadm --assemble device options...

Usage: mdadm --assemble --scan options...

This usage assembles one or more raid arrays from pre-existing components. For each array, mdadm needs to know the md device, the identity of the array, and a number of sub devices. These can be found in a number of ways. The md device is either given before --scan or is found from the config file. In the latter case, multiple md devices can be started with a single mdadm command. The identity can be given with the --uuid option, with the --super-minor option, can be found in in the config file, or will be taken from the super block on the first subdevice listed on the command line. Devices can be given on the --assemble command line or from the config file. Only devices which have an md superblock which contains the right identity will be considered for any device. The config file is only used if explicitly named with --config or requested with --scan. In the later case, /etc/mdadm.conf is used. If --scan is not given, then the config file will only be used to find the identity of md arrays. Normally the array will be started after it is assembled. However is --scan is not given and insufficient drives were lists to start a complete (non-degraded) array, then the array is not started (to guard against usage errors). To insist that the array be started in this case (as may work for RAID1 or RAID5), give the --run flag.

BUILD MODE

Usage: mdadm --build device --chunk=X --level=Y --raid-disks=Z devices

This usage is similar to --create. The difference is that it creates a legacy array without a superblock. With these arrays there is no difference between initially creating the array and subsequently assembling the array, except that hopefully there is useful data there in the second case. The level may only be 0, raid0, or linear. All devices must be listed and the array will be started once complete.

CREATE MODE

Usage: mdadm --create device --chunk=X --level=Y
--raid-disks=Z devices

This usage will initialise a new md array, associate some devices with it, and activate the array. As devices are added, they are checked to see if they contain raid superblocks or filesystems. They are also check to see if the variance in device size exceeds 1%. If any discrepancy is found, the array will not automatically be run, though the presence of a --run can override this caution. The General Management options that are valid with --create are:

--run
    insist of running the array even if some devices look like they might be in use.

--readonly
    start the array readonly - not supported yet.

DETAIL MODE

Usage: mdadm --detail [--brief] device ...

This usage sill print out the details of the given array including a list of component devices. To determine names for the devices, mdadm searches /dev for device files with the right major and minor numbers. With --brief mdadm prints a single line that identifies the level, number of disks, and UUID of the array. This line is suitable for inclusion in /etc/mdadm.conf.

EXAMINE MODE

Usage: mdadm --examine [--scan] [--brief] device ...

This usage will examine some block devices to see if that have a valid RAID superblock on them. The information in each valid raid superblock will be printed. If --scan is used, the no devices should be listed, and the complete set of devices identified in the configuration file are checked. --scan implies --brief but this implication can be countered by specifying --verbose. With --brief mdadm will output an config file entry of each distinct array that was found. This entry will list the UUID, the raid level, and a list of the individual devices on which a superblock for that array was found. This output will by syntactically suitable for inclusion in the configuration file, but should NOT be used blindly. Often the array description that you want in the configuration file is much less specific than that given by mdadm -Bs. For example, you normally do not want to list the devices, particularly if they are SCSI devices.

FILES

  /proc/mdstat
If you're using the /proc filesystem, /proc/mdstat gives you informations about md devices status. This file is not currently used by mdadm.

  /etc/mdadm.conf
The config file is line oriented with, as usual, blank lines and lines beginning with a hash (or pound sign or sharp or number sign, whichever you like to call it) ignored. Lines that start with a blank are treated as continuations of the previous line (I don't like trailing slashes). Each line contains a sequence of space-separated words, the first of which identified the type of line. Keywords are case-insensitive, and the first work on a line can be abbreviated to 3 letters. There are two types of lines. ARRAY and DEVICE. The DEVICE lines usually come first. All remaining words on the line are treated as names of devices, possibly containing wild cards (see glob(7)). These list all the devices that mdadm is allowed to scan when looking for devices with RAID superblocks. Each line can contain multiple device names, and there can be multiple DEVICE lines. For example:

    DEVICE /dev/hda* /dev/hdc*
    DEV /dev/sd*
    DEVICE /dev/discs/disc*/disc

The ARRAY lines identify actual arrays. The second word on the line should be the name of the device where the array is normally assembled, such as /dev/md1. Subsequent words identify the array. If multiple identities are given, then the array much match ALL identities to be considered a match. Each identity word has a tag, and equals sign, and some value. The options are:

uuid=
    The value should be a 128 bit uuid in hexadecimal, with punctuation interspersed if desired. This must match the uuid stored in the superblock.

super-minor=
    The value is an integer which indicates the minor number that was stored in the superblock when the array was created. When an array is created as /dev/mdX, then the minor number X is stored.

devices=
    The value is a comma separated list of device names. Precisely these devices will be used to assemble the array. Note that the devices listed there must also be listed on a DEVICE line.

level=
    The value is a raid level. This is normally used to identify an array, but is supported so that the output of mdadm --examine --scan can be use directly in the configuration file.

disks=
    The value is the number of disks in a complete active array. As with level= this is mainly for compatibility with the output of mdadm --examine --scan.

TODO
Finish and document Follow mode.

SEE ALSO
For information on the various levels of RAID, check out:

    http://ostenfeld.dk/~jakob/Software-RAID.HOWTO/ (http://ostenfeld.dk/~jakob/Software-RAID.HOWTO/)

for new releases of the RAID driver check out:

    ftp://ftp.kernel.org/pub/linux/kernel/people/mingo/raid-patches (ftp://ftp.kernel.org/pub/linux/kernel/people/mingo/raid-patches)

or

    http://www.cse.unsw.edu.au/~neilb/patches/linux-stable/

raidtab(5), raid0run(8), raidstop(8), mkraid(8)